Unit iah1e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure iah1e(A :Extended; B :Extended; var C :Array of Extended;
                N :Integer; FUNC :Func_F1E; var RF :Array of Extended);

implementation

procedure iah1e(A :Extended; B :Extended; var C :Array of Extended;
                N :Integer; FUNC :Func_F1E; var RF :Array of Extended);
var
J,K :Integer;
SUM,BMA,BPA,Y,FAC :Extended;
const
SYS001 :Extended = 3.1415926535897932384626433832795;
label
_10,_30,_20;
begin
BMA := (B-A)*0.5e0;
BPA := (B+A)*0.5e0;
for K:=1 to N do
 begin
  Y := Cos(SYS001*(K-0.5e0)/N);
  RF[K-1] := FUNC(Y*BMA+BPA);
_10:
 end;
FAC := 2.0e0/N;
for J:=1 to N do
 begin
  SUM := 0.0;
  for K:=1 to N do
   begin
    SUM := SUM+RF[K-1]*Cos((SYS001*(J-1))*((K-0.5e0)/N));
_30:
   end;
  C[J-1] := FAC*SUM;
_20:
 end;
end;

end.
